﻿///////////////////////////////////////////////////////////////////////////////
//
//    (C) Copyright 2011 EaseVault Technologies Inc.
//    All Rights Reserved
//
//    This software is part of a licensed software product and may
//    only be used or copied in accordance with the terms of that license.
//
///////////////////////////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Diagnostics;

namespace CSharpDemo
{
    static public class EventMessage
    {
        static ListView listViewMessage = null;
        static uint messageId = 0;

        static public void SetListViewMessage(ListView lvMessage)
        {
            listViewMessage = lvMessage;

            listViewMessage.Clear();		//clear control
            //create column header for ListView
            listViewMessage.Columns.Add("#", 40, System.Windows.Forms.HorizontalAlignment.Left);
            listViewMessage.Columns.Add("Time", 150, System.Windows.Forms.HorizontalAlignment.Left);
            listViewMessage.Columns.Add("Message", 600, System.Windows.Forms.HorizontalAlignment.Left);
            listViewMessage.Columns.Add("Caller Name",400, System.Windows.Forms.HorizontalAlignment.Left);

        }

        static string FormatDateTime(DateTime dateTime)
        {
            return dateTime.ToShortDateString() + " " + dateTime.ToShortTimeString();
        }

        static string StackTrace()
        {
           StackTrace st = new StackTrace(false);

           string stackTrace = string.Empty;

           int i = 2;
            //for (int i = 2; i < st.FrameCount; i++)
            {
                // Note that at this level, there are four
                // stack frames, one for each method invocation.
                StackFrame sf = st.GetFrame(i);
                stackTrace += string.Format("Frame#:{0} Method: {1}",i,sf.GetMethod()) + Environment.NewLine;
                stackTrace += string.Format(" File: {0}",sf.GetFileName()) + Environment.NewLine;
                stackTrace += string.Format(" Line Number: {0}",sf.GetFileLineNumber()) + Environment.NewLine;
            }

            stackTrace += Environment.NewLine;

            return stackTrace;
        }

        static public void LogInfoMessage(string info)
        {
            string[] itemStr = new string[listViewMessage.Columns.Count];
            itemStr[0] = (messageId++).ToString();
            itemStr[1] = FormatDateTime(DateTime.Now);
            itemStr[2] = info;
            itemStr[3] = StackTrace();

            ListViewItem item = new ListViewItem(itemStr, 0);
            listViewMessage.Items.Add(item);
        }
       
        static public void LogErrorMessage(string errorMessage)
        {
            string[] itemStr = new string[listViewMessage.Columns.Count];
            itemStr[0] = (messageId++).ToString();
            itemStr[1] = FormatDateTime(DateTime.Now);
            itemStr[2] = errorMessage;
            itemStr[3] = StackTrace();

            ListViewItem item = new ListViewItem(itemStr, 0);
            item.BackColor = Color.LightGray;
            item.ForeColor = Color.Red;
            listViewMessage.Items.Add(item);

        }
    }
}
