﻿
///////////////////////////////////////////////////////////////////////////////
//
//    (C) Copyright 2011 EaseVault Technologies Inc.
//    All Rights Reserved
//
//    This software is part of a licensed software product and may
//    only be used or copied in accordance with the terms of that license.
//
///////////////////////////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Security.Principal;
using System.IO;


namespace CSharpDemo
{
    public class FilterTest
    {         
         public FilterTest()
         {
         }

         public bool ProcessReplyMessage(EaseFilter.MessageSendData messageSend, IntPtr replyDataPtr)
         {
             bool ret = true;

             try
             {
                 EaseFilter.MessageReplyData messageReply = new EaseFilter.MessageReplyData();
                 messageReply = (EaseFilter.MessageReplyData)Marshal.PtrToStructure(replyDataPtr, typeof(EaseFilter.MessageReplyData));
                 
                 messageReply.MessageId = messageSend.MessageId;
                 messageReply.MessageType = messageSend.MessageType;

                 ReplyDataForm replyForm = new ReplyDataForm(messageSend,messageReply);

                 messageReply = replyForm.MessageReply;

                 if (!replyForm.ProcessReplyDataNeeded || (replyForm.ShowDialog() != DialogResult.OK))
                 {
                     messageReply.FilterStatus = 0;
                     messageReply.ReturnStatus = (uint)NtStatus.Status.Success;
                 }
                 
                 Marshal.StructureToPtr(replyForm.MessageReply, replyDataPtr, true);
             }
             catch (Exception ex)
             {
                 EventMessage.LogErrorMessage("ProcessReplyMessage failed." + ex.Message);
             }

             return ret;
         }
       

        
    }
}
